Index: trunk/src/lib/shell/shell_command.h
===================================================================
--- trunk/src/lib/shell/shell_command.h	(revision 7377)
+++ trunk/src/lib/shell/shell_command.h	(revision 7386)
@@ -79,5 +79,5 @@
   protected:
     ShellCommand(const std::string& commandName, const std::string& className, const Executor& executor);
-    ~ShellCommand();
+    virtual ~ShellCommand();
 
     static bool isRegistered(const std::string& commandName, const std::string& className);
Index: trunk/src/lib/shell/shell_command_class.cc
===================================================================
--- trunk/src/lib/shell/shell_command_class.cc	(revision 7377)
+++ trunk/src/lib/shell/shell_command_class.cc	(revision 7386)
@@ -66,9 +66,6 @@
    * @returns true on success, false otherwise
    */
-  bool ShellCommandClass::getCommandListOfClass(const std::string& className, std::list<std::string>* stringList)
-  {
-    if (stringList == NULL)
-      return false;
-
+  bool ShellCommandClass::getCommandListOfClass(const std::string& className, std::list<std::string>& stringList)
+  {
     std::list<ShellCommandClass*>::iterator elem;
     for(elem = ShellCommandClass::commandClassList->begin(); elem != ShellCommandClass::commandClassList->end(); elem++)
@@ -78,5 +75,5 @@
         std::list<ShellCommand*>::iterator command;
         for(command = (*elem)->commandList.begin(); command != (*elem)->commandList.end(); command++)
-          stringList->push_back((*command)->getName());
+          stringList.push_back((*command)->getName());
       }
     }
@@ -89,12 +86,12 @@
    * @returns true on success, false otherwise
    */
-  bool ShellCommandClass::getCommandListOfAlias(std::list<std::string>* stringList)
-  {
-    if (stringList == NULL || ShellCommandClass::aliasList == NULL)
+  bool ShellCommandClass::getCommandListOfAlias(std::list<std::string>& stringList)
+  {
+    if (ShellCommandClass::aliasList == NULL)
       return false;
 
     std::list<ShellCommandAlias*>::iterator alias;
     for (alias = ShellCommandClass::aliasList->begin(); alias != ShellCommandClass::aliasList->end(); alias++)
-      stringList->push_back((*alias)->getName());
+      stringList.push_back((*alias)->getName());
     return true;
   }
Index: trunk/src/lib/shell/shell_command_class.h
===================================================================
--- trunk/src/lib/shell/shell_command_class.h	(revision 7377)
+++ trunk/src/lib/shell/shell_command_class.h	(revision 7386)
@@ -25,6 +25,7 @@
     /** @returns the CommandClassList */
     static const std::list<ShellCommandClass*>* getCommandClassList() { return ShellCommandClass::commandClassList; };
-    static bool getCommandListOfClass(const std::string& className, std::list<std::string>* stringList);
-    static bool getCommandListOfAlias(std::list<std::string>* aliasList);
+
+    static bool getCommandListOfClass(const std::string& className, std::list<std::string>& stringList);
+    static bool getCommandListOfAlias(std::list<std::string>& aliasList);
 
     static ShellCommandClass* getCommandClass(const std::string& className);
Index: trunk/src/lib/shell/shell_completion.cc
===================================================================
--- trunk/src/lib/shell/shell_completion.cc	(revision 7377)
+++ trunk/src/lib/shell/shell_completion.cc	(revision 7386)
@@ -170,5 +170,5 @@
   {
     std::list<std::string> fktList;
-    ShellCommandClass::getCommandListOfClass(className, &fktList);
+    ShellCommandClass::getCommandListOfClass(className, fktList);
     //printf("%s\n", boList->firstElement()->getName());
     if (!this->addToCompleteList(fktList, functionBegin, FunctionCompletion))
@@ -185,5 +185,5 @@
   {
     std::list<std::string> aliasList;
-    ShellCommandClass::getCommandListOfAlias(&aliasList);
+    ShellCommandClass::getCommandListOfAlias(aliasList);
     //printf("%s\n", boList->firstElement()->getName());
     if (!this->addToCompleteList(aliasList, aliasBegin, AliasCompletion))
Index: trunk/src/lib/shell/shell_completion_plugin.h
===================================================================
--- trunk/src/lib/shell/shell_completion_plugin.h	(revision 7377)
+++ trunk/src/lib/shell/shell_completion_plugin.h	(revision 7386)
@@ -59,5 +59,4 @@
       std::string             _subDir;
       StartDirectory          _startDir;
-
   };
 