Index: branches/atmospheric_engine/src/defs/class_id.h
===================================================================
--- branches/atmospheric_engine/src/defs/class_id.h	(revision 7383)
+++ branches/atmospheric_engine/src/defs/class_id.h	(revision 7392)
@@ -289,4 +289,5 @@
   //CL_SUN_EFFECT                 =    0x        ,
   //CL_WEATHER_EFFECT             =    0x        ,
+  //CL_FOG_EFFECT                 =    0x        ,
 
   // Particles
Index: branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc	(revision 7383)
+++ branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.cc	(revision 7392)
@@ -27,6 +27,4 @@
 using namespace std;
 
-
-
 /**
  * @param root The XML-element to load the AtmosphericEngine from
@@ -34,6 +32,6 @@
 AtmosphericEngine::AtmosphericEngine()
 {
-  //this->setClassID(CL_ATMOSPHERIC_ENGINE, "AtmosphericEngine");
-  this->bActivated = false;
+  // this->setClassID(CL_ATMOSPHERIC_ENGINE, "AtmosphericEngine");
+  // this->bActivated = false;
 }
 
@@ -92,6 +90,6 @@
  *  initializes the graphics effect
  */
-bool AtmosphericEngine::init()
-{}
+//bool AtmosphericEngine::init()
+//{}
 
 
Index: branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.h	(revision 7383)
+++ branches/atmospheric_engine/src/lib/graphics/effects/atmospheric_engine.h	(revision 7392)
@@ -15,20 +15,17 @@
 {
   public:
-    virtual ~AtmosphericEngine();
+    ~AtmosphericEngine();
 
     /** @returns a Pointer to the only object of this Class */
     inline static AtmosphericEngine* getInstance() { if (!AtmosphericEngine::singletonRef) AtmosphericEngine::singletonRef = new AtmosphericEngine();  return AtmosphericEngine::singletonRef; };
 
-    virtual void loadParams(const TiXmlElement* root);
+    void loadParams(const TiXmlElement* root);
 
-    virtual bool init();
+    // bool init();
 
-    //virtual bool activate() = 0;
-    //virtual bool deactivate() = 0;
+    void draw() const;
+    void tick(float dt);
 
-    virtual void draw() const;
-    virtual void tick(float dt);
-
-    inline bool isActivated() const { return this->bActivated; }
+    // inline bool isActivated() const { return this->bActivated; }
 
     void loadWeatherEffect(const TiXmlElement* root);
@@ -41,6 +38,6 @@
     static AtmosphericEngine*     singletonRef;       //!< Pointer to the only instance of this Class
 
-  protected:
-    bool              bActivated;
+  //protected:
+  //  bool              bActivated;
 };
 
Index: branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 7383)
+++ branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 7392)
@@ -20,5 +20,9 @@
 #include "glincl.h"
 
-
+#include "shell_command.h"
+/*SHELL_COMMAND(activateFog, FogEffect, FogEffect::activate)
+  ->setAlias("aFog");
+SHELL_COMMAND(deactivateFog, FogEffect, FogEffect::deactivate)
+  ->setAlias("dFog");*/
 
 using namespace std;
@@ -26,14 +30,13 @@
 CREATE_FACTORY(FogEffect, CL_FOG_EFFECT);
 
-
 FogEffect::FogEffect(const TiXmlElement* root)
 {
   //this->setClassID(CL_FOG_EFFECT, "FogEffect");
-/*
+
   this->fogMode = GL_LINEAR;
   this->fogDensity = 0.001f;
   this->fogStart = 10.0f;
   this->fogEnd = 1000.0f;
-*/
+
   if (root != NULL)
     this->loadParams(root);
@@ -54,12 +57,11 @@
   WeatherEffect::loadParams(root);
 
-/*
   LoadParam(root, "fog-mode", this, FogEffect, setFogMode);
 
   LoadParam(root, "fog-density", this, FogEffect, setFogDensity);
 
-  LoadParam(root, "fog-color", this, FogEffect, setFogColor);*/
+  LoadParam(root, "fog-color", this, FogEffect, setFogColor);
 
-  LoadParam(root, "test", this, FogEffect, setTest);
+  // LoadParam(root, "test", this, FogEffect, setTest);
 
 
@@ -77,11 +79,14 @@
 
 bool FogEffect::activate()
-{/*
+{
   PRINTF(0)( "Enabling Fog Effect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity,
              this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
 
+  /*PRINTF(0)( "Enabling Fog Effect, mode: %i, density: %f, start: %f, end: %f\n", this->fogMode, this->fogDensity,
+             this->fogStart, this->fogEnd);*/
+
   glEnable(GL_FOG);
   {
-//     GLfloat fogColor[4] = {0.7, 0.6, 0.6, 1.0};
+    //GLfloat fogColor[4] = {0.7, 0.6, 0.6, 1.0};
     GLfloat fogColor[4] = { colorVector.x, colorVector.y, colorVector.z, 1.0};
 
@@ -95,5 +100,5 @@
     //glFogi(GL_FOG_COORDINATE_SOURCE, GL_FOG_COORDINATE);
   }
-  glClearColor(0.5, 0.5, 0.5, 1.0);*/
+  glClearColor(0.5, 0.5, 0.5, 1.0);
 }
 
@@ -102,9 +107,9 @@
 bool FogEffect::deactivate()
 {
-  //glDisable(GL_FOG);
+	glDisable(GL_FOG);
 }
 
 
-/*
+
 GLint FogEffect::stringToFogMode(const std::string& mode)
 {
@@ -118,4 +123,4 @@
     return -1;
 }
-*/
 
+
Index: branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 7383)
+++ branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 7392)
@@ -5,4 +5,6 @@
 #ifndef _FOG_EFFECT
 #define _FOG_EFFECT
+
+#include "vector.h"
 
 #include "weather_effect.h"
@@ -24,20 +26,20 @@
     void setTest(int test);
 
-    /*inline void setFogMode(const std::string& mode) { this->fogMode = this->stringToFogMode(mode); }
+    inline void setFogMode(const std::string& mode) { this->fogMode = this->stringToFogMode(mode); }
     inline void setFogDensity(float density) { this->fogDensity = density; }
     inline void setFogRange(float start, float end) { this->fogStart = start; this->fogEnd = end; }
     inline void setFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
-*/
-
-  private:
-    //GLint stringToFogMode(const std::string& mode);
 
 
   private:
-   /* GLint                   fogMode;
+    GLint stringToFogMode(const std::string& mode);
+
+
+  private:
+    GLint                   fogMode;
     GLfloat                 fogDensity;
     GLfloat                 fogStart;
     GLfloat                 fogEnd;
-    Vector                  colorVector;*/
+    Vector                  colorVector;
 };
 