Index: code/branches/ipv6/src/external/enet/host.c
===================================================================
--- code/branches/ipv6/src/external/enet/host.c	(revision 7396)
+++ code/branches/ipv6/src/external/enet/host.c	(revision 7397)
@@ -15,4 +15,7 @@
         return ENET_SOCKET_NULL;
 
+    /* This is not a conditional bind anymore,
+     * because WSARecvFrom returned WSAEINVAL on the IPv6 socket.
+     * TODO: Check for it's consequences. */
     if (enet_socket_bind (socket, address, family) < 0)
     {
Index: code/branches/ipv6/src/external/enet/include/enet/enet.h
===================================================================
--- code/branches/ipv6/src/external/enet/include/enet/enet.h	(revision 7396)
+++ code/branches/ipv6/src/external/enet/include/enet/enet.h	(revision 7397)
@@ -59,9 +59,14 @@
 } ENetHostAddress;
 
-ENET_API const ENetHostAddress ENET_HOST_ANY;          /**< specifies the default server host */
-ENET_API const ENetHostAddress ENET_IPV4MAPPED_PREFIX; /**< specifies the IPv4-mapped IPv6 prefix */
-ENET_API const ENetHostAddress ENET_HOST_BROADCAST;    /**< specifies a IPv4 subnet-wide broadcast */
-#define ENET_IPV4MAPPED_PREFIX_LEN 12                  /**< specifies the length of the IPv4-mapped IPv6 prefix */
-#define ENET_PORT_ANY 0                                /**< specifies that a port should be automatically chosen */
+#define ENET_HOST_ANY_INIT { { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } }                         /**< specifies the default server host (macro for variable initialization) */
+ENET_API const ENetHostAddress ENET_HOST_ANY;                                              /**< specifies the default server host (global constant variable) */
+#define ENET_IPV4MAPPED_PREFIX_INIT { { 0,0,0,0,0,0,0,0,0,0,0xff,0xff,0,0,0,0 } }          /**< specifies the IPv4-mapped IPv6 prefix (macro for variable initialization) */
+ENET_API const ENetHostAddress ENET_IPV4MAPPED_PREFIX;                                     /**< specifies the IPv4-mapped IPv6 prefix (global constant variable) */
+#define ENET_HOST_BROADCAST_INIT { { 0,0,0,0,0,0,0,0,0,0,0xff,0xff,0xff,0xff,0xff,0xff } } /**< specifies a IPv4 subnet-wide broadcast (macro for variable initialization) */
+ENET_API const ENetHostAddress ENET_HOST_BROADCAST;                                        /**< specifies a IPv4 subnet-wide broadcast (global constant variable) */
+enum {
+    ENET_IPV4MAPPED_PREFIX_LEN = 12,                                                       /**< specifies the length of the IPv4-mapped IPv6 prefix */
+    ENET_PORT_ANY              = 0                                                         /**< specifies that a port should be automatically chosen */
+};
 
 /**
Index: code/branches/ipv6/src/external/enet/protocol.c
===================================================================
--- code/branches/ipv6/src/external/enet/protocol.c	(revision 7396)
+++ code/branches/ipv6/src/external/enet/protocol.c	(revision 7397)
@@ -10,7 +10,7 @@
 #include "enet/enet.h"
 
-const ENetHostAddress ENET_HOST_ANY = { { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
-const ENetHostAddress ENET_IPV4MAPPED_PREFIX = { { 0,0,0,0,0,0,0,0,0,0, 0xff, 0xff, 0,0,0,0 } };
-const ENetHostAddress ENET_HOST_BROADCAST = { { 0,0,0,0,0,0,0,0,0,0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff } };
+const ENetHostAddress ENET_HOST_ANY = ENET_HOST_ANY_INIT;
+const ENetHostAddress ENET_IPV4MAPPED_PREFIX = ENET_IPV4MAPPED_PREFIX_INIT;
+const ENetHostAddress ENET_HOST_BROADCAST = ENET_HOST_BROADCAST_INIT;
 
 static size_t commandSizes [ENET_PROTOCOL_COMMAND_COUNT] =
@@ -33,5 +33,5 @@
 enet_address_map4 (enet_uint32 address)
 {
-    ENetHostAddress addr = ENET_IPV4MAPPED_PREFIX;
+    ENetHostAddress addr = ENET_IPV4MAPPED_PREFIX_INIT;
     ((enet_uint32 *)addr.addr)[3] = address;
     return addr;
Index: code/branches/ipv6/src/external/enet/unix.c
===================================================================
--- code/branches/ipv6/src/external/enet/unix.c	(revision 7396)
+++ code/branches/ipv6/src/external/enet/unix.c	(revision 7397)
@@ -200,8 +200,5 @@
     else
     {
-        ENetAddress address_;
-        address_.host = ENET_HOST_ANY;
-        address_.scopeID = 0;
-        address_.port = 0;
+        ENetAddress address_ = { ENET_HOST_ANY_INIT, 0, 0 };
         enet_address_set_sin((struct sockaddr *) & sin, & address_, family);
     }
Index: code/branches/ipv6/src/external/enet/win32.c
===================================================================
--- code/branches/ipv6/src/external/enet/win32.c	(revision 7396)
+++ code/branches/ipv6/src/external/enet/win32.c	(revision 7397)
@@ -181,8 +181,5 @@
     else
     {
-        ENetAddress address_;
-        address_.host = ENET_HOST_ANY;
-        address_.scopeID = 0;
-        address_.port = 0;
+        ENetAddress address_ = { ENET_HOST_ANY_INIT, 0, 0 };
         enet_address_set_sin((SOCKADDR *) & sin, & address_, family);
     }